<template>
    <div class="content__leftAnalitika">
        <div class="pc vld-parent">
            <p class="text-title">{{ $t('payment_systems.title') }}</p>
            <loading :active="show_loading"
                     :can-cancel="false"
                     :is-full-page="true">
                <hollow-dots-spinner
                    :animation-duration="1000"
                    :dot-size="30"
                    :dots-num="3"
                    color="#3068e8"
                />
            </loading>
            <transition-group name="fadeUp" tag="div" class="box-pc--flex">
                <payment-system
                    v-for="(payment_system, i) in payment_systems"
                    :is_all_loading="is_loading"
                    :delay="i * 0.2"
                    :key="payment_system.id"
                    :payment_system="payment_system"
                    :style="delayStyle(i)"
                    @deleted="deleteItem"
                    @loading="balanceLoading"
                />
                <div class="box__pc--add" :style="delayStyle(addIndex)" @click="add" key="add">
                    <p class="text-blueAdd">{{ $t('payment_systems.add_button_first') }}<span>{{ $t('payment_systems.add_button_second') }}</span></p>
                    <img src="/img/blueblock.png" alt="" class="blue-img">
                </div>
                <div class="box__pc--add" :style="delayStyle(updateIndex)" @click="loadBalances" key="update_rates">
                    <p class="text-blueAdd">{{ $t('payment_systems.update_button_first') }}<span>{{ $t('payment_systems.update_button_second') }}</span></p>
                    <img src="/img/blueblock.png" alt="" class="blue-img">
                </div>
            </transition-group>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import route from "../mixins/route";
    import PaymentSystem from "../components/payment_systems/PaymentSystem";
    import _ from 'lodash';
    import Loading from 'vue-loading-overlay';
    import {HollowDotsSpinner} from 'epic-spinners'

    export default {
        name: "PaymentSystems",
        mixins: [route],
        data(){
            return {
                payment_systems: [],
                is_loading: false,
                show_loading: false,
            }
        },
        watch: {
            is_loading(val){
                this.show_loading = val;
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
            addIndex(){
                return Array.isArray(this.payment_systems) ? this.payment_systems.length : 0
            },
            updateIndex(){
                return Array.isArray(this.payment_systems) ? this.payment_systems.length + 1 : 0
            },
        },
        methods: {
            load(){
                this.axios
                    .get('payment_systems')
                    .then(resp => resp.data)
                    .then(payment_systems => this.payment_systems = payment_systems)
                ;
            },
            loadBalances(){
                this.is_loading = true;
                this.$emit('loading', true);
                this.axios
                    .get(`payment_systems/balances`)
                    .then(resp => resp.data)
                    .then(data => {
                        console.log(data);
                        if(data.success > 0){
                            this.$swal('Загружено', `Успешно: ${data.success}<br>С ошибкой: ${data.errors}`, 'success');
                            const balances = data.balances;
                            this.payment_systems = _.map(this.payment_systems, payment_system => {
                                return {
                                    ...payment_system,
                                    balance: balances.hasOwnProperty(payment_system.id) ? balances[payment_system.id] : 0
                                }
                            });
                        }else{
                            this.$swal('Ошибка при загрузке', `Балансы не получены`, 'error');
                        }
                    })
                    .finally(() => {
                        this.is_loading = false;
                        this.$emit('loading', false);
                    })
                ;
            },
            balanceLoading(val){
                this.show_loading = val;
            },
            delayStyle(index){
                const delay = index * 0.2;
                return delay ? {
                    'animation-delay': Number.parseFloat(delay).toFixed(2)+'s',
                } : { };
            },
            deleteItem(id){
                const idx = _.findIndex(this.payment_systems, {id : id});
                this.payment_systems.splice(idx, 1);
            },
            add(){
                this.$router.push(this.route('payment_systems_create'));
            }
        },
        mounted() {
            this.load();
        },
        components: {
            PaymentSystem, Loading, HollowDotsSpinner
        }
    }
</script>

<style scoped lang="scss">
    .box__pc--add{
        cursor: pointer;
    }
</style>
